# 4.1.0

- Upgraded native plugin to 4.1.0
- Added a cancel button to the progress overlay which shows up after 4 seconds and ends the session. This is in the case the USSD session hangs underneath

# 4.0.0

**OFFICIAL v4 RELEASE**

- New Features
  - Implemented **Session Branching**. Session branching allows the SDK to fallback to another menu path if a mismatch occurs in the session. This feature allows devs to model USSD services where the menus are different based on the type of user accessing it.
  - Added a new **Choice** session menu. When a _choice_ menu is reached, the SDK shows the underlying USSD and waits for the user to make a selection before resuming execution.
  - ❤️❤️❤️ Added **Dynamic Sessions** (by popular request). Dynamic sessions take the underlying USSD and generates dynamic UI from them. The user can then interact with the generated UI as they would with the traditional UI.
  - ❤️❤️❤️ Added **UI Customization** (by popular request). You can now customize the look of the SDK to match your brand. Use the `AutoUssd.getInstance().setOverlayTheme()` method to do this.
- Bug Fixes
  - New singleton API. Instead of `AutoUssd.<method call>`, use `AutoUssd.getInstance().<method call>`.
  - Changed session **variables type** from `List` to `Map`. This allow variable reuse within the SDK.

# 4.0.0-alpha-09

- Added progress bars to overlay views to indicate how much time user has before the session is auto-terminated
- Added a cancel button to the text input overlay to allow the user cancel the session prematurely
- Added theming capabilities to SDK to customize to specific brand. However, the theme retains the "**Powered by AutoUssd**" tag

# 4.0.0-alpha-02

- Incremented `minSdkVersion` to 26 (Android 8)
- Added new session branch feature which allow the SDK to branch of a session unto an alternate menu path if a mismatch occurs in the session
- Added `Choice` menu feature which halt the SDK during execution at a specific menu and waits for the user to make a selection before resuming execution
- Added dynamic sessions feature which parses the USSD string into UI elements on-the-fly. The user can then interact with the dynamically created views instead of the USSD dialog
- Changed session variable type from `List` to `Map`

# 3.2.0

- Upgraded native plugin to 3.2.0
- Updated native plugin to use new AutoUssd API

# 3.1.0

- Added `AutoUssdFlutter.getDeviceSimNetworks` function which returns a list of `Network` of the SIM cards in the device.
- Added `name`, `countryName`, `countryIsoCode` and `countryDialCode` to `Network` model class.

# 3.0.2

- V3 official release

# 3.0.2-alpha-01

**BREAKING CHANGES**

- Refactored `AutoUssdFlutter` to a static implementation
- Added automatic SIM determination. The SDK will determine the right SIM to use based on the
  session's networks.
- Added SIM override support. A SIM can be specified by
  a [mobile country code (mcc)](https://en.wikipedia.org/wiki/Mobile_country_code) and
  a [mobile network code (mnc)](https://en.wikipedia.org/wiki/Mobile_country_code) to instruct the
  SDK will forcefully use the matching SIM to execute the session
- Upgraded native plugin to 3.0.2

# 2.1.0

- Upgraded native plugin to 2.1.0

# 2.0.4

- Upgraded native plugin to 2.0.4

# 2.0.3

- Upgraded native plugin to 2.0.3

# 2.0.2

- Upgraded Gradle plugin to 7.1.2
- Upgraded native plugin to 2.0.2

# 2.0.1

- Upgraded native plugin to 2.0.1
- Fixed bug causing variable menus to fail during session execution

# 2.0.0-alpha-01

* Upgraded native plugin to 2.0.0
* Refactored the AutoUssdFlutter constructor to accept an `onSessionCount` callback function

# 1.0.0-alpha-02

* Fixed Android plugin buildscript

# 1.0.0-alpha-01

* Exposed `AutoUssdFlutter` class
* Exposed `AutoUssdResult` class. `AutoUssdResult` represents the session execution result
* Export `AutoUssdResultStatus` enumeration. `AutoUssdResultStatus` represents the status of
  an `AutoUssdResult` instance
